#include <iostream>
#include <PointCloud.h>
#include <PointCloudUtil.h>
#include <fstream>

#include <Dataset.h>
#include <IntensityPanorama.h>

int main()
{
#if 0
	PMap::PointCloud3d p;
	p.resize(2);

	p.getPoints().col(0)=Eigen::Vector3d(1,2,3);
	p.getPoints().col(1)=Eigen::Vector3d(4,5,6);

	Eigen::Matrix3d R=Eigen::Matrix3d::Identity()*5;
	Eigen::Vector3d t;
	t<<0,0,1;

	auto s2=PMap::transformed(p,R,t);

	std::cout << p.getPoints().transpose () << std::endl;
	std::cout << s2.getPoints().transpose () << std::endl;

	auto s3=PMap::simpleSubsample(s2,2);
	std::cout << s3.getPoints().transpose () << std::endl;

	auto s4=PMap::loadPointCloudFromBin("/run/media/fneuhaus/Windows7_OS/Audi/audipmap/zfs2bin-build/b.bin");
	std::cout << s4.getPoints().cols() << std::endl;

	auto s5=PMap::simpleSubsample(s4,100);
	std::cout << "done" << std::endl;
	std::ofstream test("test.txt");
	for (int i=0;i<s5.getPoints().cols();i++)
	{
		test << s5.getPoints().col(i).transpose() << "\n";
	}
	test << std::flush;
#else
	PMap::Dataset ds("/home/fneuhaus/work/audipmap/data/test/data.js");

	for (auto& e:ds.entries())
	{
		std::cout << e.pose.transpose() << std::endl;


		//e.cloud.allocateIntensities();
		//for (int i=0;i<e.cloud.getPoints().cols();i++)
			//e.cloud.getIntensities()[i]=std::min(1.0,std::max(0.0,e.cloud.getPoints().col(i).norm()/10.0));
		std::cout << "NumPts: " << e.cloud.getPoints().cols() << std::endl;
		//e.cloud
		//cv::Mat pano=PMap::intensityPanoramaFromCloud(e.cloud,6000,3000);
		PMap::IntensityPanorama pano(e.cloud,6000,3000);
		cv::imwrite("test.jpg",pano.getPanorama());


		std::ofstream test("test.txt");
		for (int i=0;i<e.cloud.getPoints().cols();i+=100)
		{
			test << e.cloud.getPoints().col(i).transpose() << "\n";
		}

	}
#endif
}
